/**
 * 
 */
package no.uia.smile.unik9710;

import java.io.File;
import java.util.Map;
import java.util.Set;

import com.clarkparsia.owlapi.explanation.DefaultExplanationGenerator;
import com.clarkparsia.owlapi.explanation.SingleExplanationGeneratorImpl;
import com.clarkparsia.owlapi.explanation.util.ExplanationProgressMonitor;
import com.clarkparsia.owlapi.explanation.util.SilentExplanationProgressMonitor;
import com.clarkparsia.pellet.owlapiv3.PelletReasonerFactory;
import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.io.OWLObjectRenderer;
import org.semanticweb.owlapi.model.*;
import org.semanticweb.owlapi.reasoner.NodeSet;
import org.semanticweb.owlapi.reasoner.OWLReasoner;
import org.semanticweb.owlapi.reasoner.OWLReasonerFactory;
import org.semanticweb.owlapi.reasoner.SimpleConfiguration;
import org.semanticweb.owlapi.vocab.OWLRDFVocabulary;
import org.semanticweb.owlapi.vocab.PrefixOWLOntologyFormat;
import uk.ac.manchester.cs.bhig.util.Tree;
import uk.ac.manchester.cs.owl.explanation.ordering.DefaultExplanationOrderer;
import uk.ac.manchester.cs.owl.explanation.ordering.ExplanationTree;
import uk.ac.manchester.cs.owl.owlapi.OWLObjectInverseOfImpl;
import uk.ac.manchester.cs.owlapi.dlsyntax.DLSyntaxObjectRenderer;

/**
 * @author TRINH courtesy http://dior.ics.muni.cz/~makub/owl/
 */
public class CopyOfmain {

	private static OWLObjectRenderer renderer = new DLSyntaxObjectRenderer();
	private static final String BASE_URL = "http://www.lehigh.edu/~zhp2/2004/0401/univ-bench.owl";

	/**
	 * @param args
	 * @throws OWLOntologyCreationException
	 */
	public static void main(String[] args) throws OWLOntologyCreationException {
		// TODO Auto-generated method stub
		OWLOntologyManager manager = OWLManager.createOWLOntologyManager();
		File file = new File("univ-bench.owl");
		OWLDataFactory factory = manager.getOWLDataFactory();
		// Now load ontology
		OWLOntology ontology = manager.loadOntologyFromOntologyDocument(file);
		System.out.println(ontology.getOntologyID());
		// Pellet reasoner
		OWLReasonerFactory reasonerFactory = PelletReasonerFactory
				.getInstance();
		OWLReasoner reasoner = reasonerFactory.createReasoner(ontology,
				new SimpleConfiguration());
		
		PrefixOWLOntologyFormat pm = manager.getOntologyFormat(ontology)
				.asPrefixOWLOntologyFormat();
		pm.setDefaultPrefix(BASE_URL + "#");

		System.out.println("--------get all individuals of the class Person------------");
		OWLClass personClass = factory.getOWLClass(":Person", pm);
		for (OWLNamedIndividual person : reasoner.getInstances(personClass,
				false).getFlattened()) {
			System.out.println("person : " + renderer.render(person));
		}

		System.out.println("--------get all info of a given individual------------");

		OWLNamedIndividual trinh = factory.getOWLNamedIndividual(
				":TrinhNguyen", pm);

		OWLObjectProperty degreeFrom = factory.getOWLObjectProperty(
				":degreeFrom", pm);
		for (OWLNamedIndividual ind : reasoner.getObjectPropertyValues(trinh,
				degreeFrom).getFlattened()) {
			System.out.println("Trinh Nguyen has a degree from "
					+ renderer.render(ind));
		}
		// get values of selected properties on the individual
		OWLDataProperty hasEmailProperty = factory.getOWLDataProperty(
				":emailAddress", pm);

		for (OWLLiteral email : reasoner.getDataPropertyValues(trinh,
				hasEmailProperty)) {
			System.out.println("Trinh Nguyen has email: " + email.getLiteral());
		}
		OWLObjectProperty hasAdvisor = factory.getOWLObjectProperty(":advisor",
				pm);
		for (OWLNamedIndividual ind : reasoner.getObjectPropertyValues(trinh,
				hasAdvisor).getFlattened()) {
			String adv = renderer.render(ind);
			System.out.println("Trinh Nguyen has advisor: " + adv);
			// get TrinhNguyen's advisor info
			OWLNamedIndividual trinhAdv = factory.getOWLNamedIndividual(":"
					+ adv, pm);
			// get values of selected properties on the individual
			hasEmailProperty = factory.getOWLDataProperty(":emailAddress", pm);

			for (OWLLiteral email : reasoner.getDataPropertyValues(trinhAdv,
					hasEmailProperty)) {
				System.out.println("                    "+ adv + " has email: " + email.getLiteral());
			}
		}
		System.out.println("----get inverse of a property, i.e. which individuals are in relation with a given individual---------");
		OWLNamedIndividual prinz = factory.getOWLNamedIndividual(
				":AndreasPrinz", pm);
		OWLObjectPropertyExpression inverse = new OWLObjectInverseOfImpl(
				factory, hasAdvisor);
		for (OWLNamedIndividual ind : reasoner.getObjectPropertyValues(prinz,
				inverse).getFlattened()) {
			System.out.println("AndreasPrinz inverseOf(hasAdvisor) -> "
					+ renderer.render(ind));
		}
		System.out.println("-------Josef Noll--------");

		OWLNamedIndividual josef = factory.getOWLNamedIndividual(":JosefNoll",
				pm);
		OWLObjectProperty memberOf = factory.getOWLObjectProperty(":memberOf",
				pm);
		for (OWLNamedIndividual ind : reasoner.getObjectPropertyValues(josef,
				memberOf).getFlattened()) {
			System.out.println("Josef Noll is a member of : "
					+ renderer.render(ind));
		}

		OWLObjectProperty teacherOf = factory.getOWLObjectProperty(
				":teacherOf", pm);
		for (OWLNamedIndividual ind : reasoner.getObjectPropertyValues(josef,
				teacherOf).getFlattened()) {
			System.out.println("Josef Noll is a teacher of : "
					+ renderer.render(ind));
		}

		inverse = new OWLObjectInverseOfImpl(factory, memberOf);
		OWLNamedIndividual university_of_oslo = factory.getOWLNamedIndividual(
				":University_of_Oslo", pm);
		for (OWLNamedIndividual ind : reasoner.getObjectPropertyValues(
				university_of_oslo, inverse).getFlattened()) {
			System.out.println("University of Oslo inverseOf(memberOf) -> "
					+ renderer.render(ind));
		}

		System.out.println("----find to which classes the individual belongs-----");
		Set<OWLClassExpression> assertedClasses = trinh.getTypes(ontology);
		for (OWLClass c : reasoner.getTypes(trinh, false).getFlattened()) {
			boolean asserted = assertedClasses.contains(c);
			System.out.println((asserted ? "asserted" : "inferred")
					+ " class for Trinh Nguyen: " + renderer.render(c));
		}
		System.out.println("----list all object property values for the individual-----");

		Map<OWLObjectPropertyExpression, Set<OWLIndividual>> assertedValues = trinh
				.getObjectPropertyValues(ontology);
		for (OWLObjectProperty objProp : ontology
				.getObjectPropertiesInSignature(true)) {
			for (OWLNamedIndividual ind : reasoner.getObjectPropertyValues(
					trinh, objProp).getFlattened()) {
				if (assertedValues.get(objProp) != null){
					boolean asserted = assertedValues.get(objProp)
							.contains(ind);
					System.out.println((asserted ? "asserted" : "inferred")
							+ " object property for Trinh Nguyen: "
							+ renderer.render(objProp) + " -> "
							+ renderer.render(ind));
					}
			}
		}
		System.out.println("------List all same individuals----------");
		for (OWLNamedIndividual ind : reasoner.getSameIndividuals(trinh)) {
			System.out.println("same as Trinh Nguyen: " + renderer.render(ind));
		}
		System.out.println("------ask reasoner whether Josef is employed at Oslo----------");
		boolean result = reasoner.isEntailed(factory
				.getOWLObjectPropertyAssertionAxiom(memberOf, josef,
						university_of_oslo));
		System.out.println("Is Josef Noll employed at University of Oslo ? : "
				+ result);

		System.out.println("-------List all SWRL rules------");
		listSWRLRules(ontology, pm);
		
		
		System.out.println("-----is Trinh Nguyen a student of Josef Noll");
		OWLObjectProperty hasStudent = factory.getOWLObjectProperty(
				":hasStudent", pm);
		OWLObjectPropertyAssertionAxiom axiomToExplain = factory.getOWLObjectPropertyAssertionAxiom(hasStudent, josef, trinh);
		System.out.println("Is Trinh Nguyen a student of Josef Noll? "+ reasoner.isEntailed(axiomToExplain));
		
		System.out.println("-------Find all students of Josef Noll--------");
		
		NodeSet<OWLNamedIndividual> josefsStudents = reasoner.getObjectPropertyValues(josef, hasStudent);
		Set<OWLNamedIndividual> values = josefsStudents.getFlattened();
		
		System.out.println("The hasStudent property values for Josef Noll are: ");
		for(OWLNamedIndividual ind : values) {
			System.out.println("    " + ind + " --> "+ renderer.render(ind));
		}
		
		
		//result = reasoner.isEntailed(factory.getOWLObjectPropertyAssertionAxiom(hasStudent, josef, trinh));
        //explain why TrinhNguyen is a student of Josef Noll
/*        DefaultExplanationGenerator explanationGenerator = 
                new DefaultExplanationGenerator( 
                        manager, reasonerFactory, ontology, reasoner, new SilentExplanationProgressMonitor()); 
        Set<OWLAxiom> explanation = explanationGenerator.getExplanation(axiomToExplain);
        DefaultExplanationOrderer deo = new DefaultExplanationOrderer(); 
        ExplanationTree explanationTree = deo.getOrderedExplanation(axiomToExplain, explanation); 
        System.out.println(); 
        printIndented(explanationTree, "");*/
		
	}
	private static void printIndented(Tree<OWLAxiom> node, String indent) { 
        OWLAxiom axiom = node.getUserObject(); 
        System.out.println(indent + renderer.render(axiom)); 
        if (!node.isLeaf()) { 
            for (Tree<OWLAxiom> child : node.getChildren()) { 
                printIndented(child, indent + "    "); 
            } 
        } 
    } 
	public static void listSWRLRules(OWLOntology ontology,
			PrefixOWLOntologyFormat pm) {
		OWLObjectRenderer renderer = new DLSyntaxObjectRenderer();
		for (SWRLRule rule : ontology.getAxioms(AxiomType.SWRL_RULE)) {
			System.out.println(renderer.render(rule));
		}
	}

	public static void listAllDataPropertyValues(OWLNamedIndividual individual,
			OWLOntology ontology, OWLReasoner reasoner) {
		OWLObjectRenderer renderer = new DLSyntaxObjectRenderer();
		Map<OWLDataPropertyExpression, Set<OWLLiteral>> assertedValues = individual
				.getDataPropertyValues(ontology);
		for (OWLDataProperty dataProp : ontology
				.getDataPropertiesInSignature(true)) {
			for (OWLLiteral literal : reasoner.getDataPropertyValues(
					individual, dataProp)) {
				Set<OWLLiteral> literalSet = assertedValues.get(dataProp);
				boolean asserted = (literalSet != null && literalSet
						.contains(literal));
				System.out.println((asserted ? "asserted" : "inferred")
						+ " data property for " + renderer.render(individual)
						+ " : " + renderer.render(dataProp) + " -> "
						+ renderer.render(literal));
			}
		}
	}

}
